<template>
  <div>
    <div class="dashboard-page-container pb-5">
      <h1 class="page-title">Set Transaction PIN</h1>
      <div class="mt-4">
        <div class="row">
          <div class="col-sm-12 col-md-10">
            <div class="card card-setting">
              <form @submit.prevent="submitForm">
                <div class="py-5 px-2">
                  <p class="fw-bold">Set Transaction PIN</p>
                  <!-- <p>
                Change your current ATM Card PIN to a <br />
                new PIN by starting with the old PIN
              </p> -->
                  <div class="pin-input-container mt-3">
                    <p class="text-muted fw-bold">New Pin</p>
                    <PincodeInput
                      v-model="form.code"
                      placeholder="0"
                      :secure="true"
                      :preview-duration="0"
                      :character-preview="false"
                    />
                  </div>
                  <div class="pin-input-container mt-3">
                    <p class="text-muted fw-bold">Confirm New Pin</p>
                    <PincodeInput
                      v-model="form.pinConfirm"
                      placeholder="0"
                      :secure="true"
                      :preview-duration="0"
                      :character-preview="false"
                    />
                  </div>
                  <div class="mt-3">
                    <!-- <button class="btn btn-primary btn-lg h6 float-end px-4">
                    Save
                  </button> -->

                    <vs-button
                      type="submit"
                      :loading="form.active"
                      primary
                      class="px-4 py-1"
                    >
                      Save
                    </vs-button>
                  </div>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// import TransferBetweenAccounts from '@/assets/icons/transfer-between-accounts.svg?inline'
// import TransferToCorebankAccount from '@/assets/icons/transfer-to-corebank-account.svg?inline'
// import TransferToOtherBanks from '@/assets/icons/transfer-to-other-banks.svg?inline'
import PincodeInput from 'vue-pincode-input'

export default {
  components: {
    PincodeInput,
  },
  layout: 'dashboard',
  data: () => ({
    form: {
      code: '',
      newCode: '',
      pinConfirm: '',
      active: false,
    },
  }),
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    submitForm() {
      if (!this.form.code || !this.form.pinConfirm) {
        this.openNotification('top-left', 'warning', 'All Fields are required ')
        return
      }

      if (
        this.form.code !== this.form.pinConfirm ||
        this.form.pinConfirm.length !== 4 ||
        this.form.code.length !== 4
      ) {
        this.openNotification('top-left', 'warning', 'Pins donts match')
        return
      }
      console.log(this.form)
      const data = {
        transactionPin: this.form.code,
      }
      this.form.active = true

      this.$axios
        .post('/transaction/pin', data)
        .then(({ data }) => {
          console.log(data)
          this.form.active = false
          // eslint-disable-next-line
          const modal = new bootstrap.Modal(
            document.getElementById('PaymentSuccessModal'),
            {}
          )
          modal.show()
          this.openNotification('top-left', 'success', data.message)
        })
        .catch((error) => {
          // console.log(error)
          this.form.active = false
          if (
            error.response.status === 404 ||
            error.response.status === 400 ||
            error.response.status === 401 ||
            error.response.status === 403 ||
            error.response.status === 406 ||
            error.response.status === 409
          ) {
            // console.log(error.response.data.message)
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          } else {
            this.openNotification(
              'top-left',
              'danger',
              error.response.data.message
            )
          }
        })
    },
  },
}
</script>

<style lang="scss">
@import '~@/assets/scss/index';
@import '~@/assets/scss/variables';

.text-sm {
  font-size: 12px;
}

.dashboard-page-container {
}
.vue-pincode-input {
  max-width: 45px !important;
  height: 50px;
  left: 468px;
  top: 729px;
  background: #f0f2f2;
  /* opacity: 0.08; */
  border-radius: 10px !important;
  box-shadow: none !important;
}
</style>
